layerInfo = {
    "Plan / Approved List":  {
        "layerName": "PlannedAppvList",
        "processType": "excelTable",
        "geometryType": None,
        "attributes": {
            "p_id": { # needs to be unique, doesn't matter if it's text, integer, etc
                "type": None,
                "att_values": None
            },
            "approved": {
                "type": 'TEXT',
                "att_values": [True, False]
            }
        }
    },
    "Recommended by Advisory Committee": {
        "layerName": "AdvisoryCommitteeRecs",
        "processType": "excelTable",
        "geometryType": None,
        "attributes": {
            "p_id": {
                "type": None,
                "att_values": None
            },
            "approved": {
                "type": 'TEXT',
                "att_values": [True, False]
            }
        }
    },  
    "Cost": {
        "layerName": "CostList",
        "processType": "excelTable",
        "geometryType": None,
        "attributes": {
            "p_id": {
                "type": None,
                "att_values": None
            },
            "cost": {
                "type": 'TEXT',
                "att_values": ["High", "Medium", "Low"]
            }
        }
    },
    "Grant Funding Candidate": {
        "layerName": "GrantFundingCandidateList",
        "processType": "excelTable",
        "geometryType": None,
        "attributes": {
            "p_id": {
                "type": None,
                "att_values": None
            },
            "candidate": {
                "type": 'TEXT',
                "att_values": [True, False]
            }
        }
    },
    "Coincides with Planned Roadway Improvement / Maint": {
        "layerName": "CoincidesPlannedRoadwayImprovement",
        "processType": "excelTable", 
        "geometryType": None,
        "attributes": {
            "p_id": {
                "type": None,
                "att_values": None
            },
            "coincides": {
                "type": 'TEXT',
                "att_values": [True, False]
            }
        }
    },
    "Pedestrian Network":  {
        "layerName": "PedestrianNetwork",
        "processType": "CheckAttributes",
        "geometryType": ["Polyline", "Multipolyline"],
        "attributes": {
            "p_id": {
                "type": None,
                "att_values": None
            },
            "CateTitle": {
                "type": 'text',
                "att_values": ['crosswalk_continental', 'crosswalk_standard', 'crosswalk_other', 'crosswalk_ladder', 'crosswalk_unmarked', 'pedestrian_bridge', 'sidewalk']
            }
        }
    },            
    "Population Counts":  {
        "layerName": "PopulationCounts",
        "processType": "CheckAttributes", 
        "geometryType": ["Polygon", "Multipolygon"],
        "attributes": {
            "p_id": {
                "type": None,
                "att_values": None
            },
            "tot_pop": {
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            }
        }
    },  
    "Employment Counts":  {
        "layerName": "EmploymentCounts",
        "processType": "CheckAttributes",
        "geometryType": ["Polygon", "Multipolygon"],
        "attributes": {
            "p_id": {
                "type": None,
                "att_values": None
            },
            "tot_emp": {
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            }
        }
    },
    "Vulnerable Populations Index":  {
        "layerName": "VulnerablePopulationsIndex",
        "processType": "CheckAttributes",
        "geometryType": ["Polygon", "Multipolygon"],
        "attributes": {
            "p_id": { # unique identifier
                "type": None,
                "att_values": None
            },
            "GEOID": { 
                "type": None,
                "att_values": None
            },
            "cnt_hh_pvr": { # count of households in poverty 
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            },
            "cnt_hh_noc": { # count of zero car households
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            },
            "cnt_not_wh": { # count of non white population
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            },   
            "cnt_lep": { # count of population that speaks little or no english
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            },
            "cnt_hisp": { # count of Hispanic population 
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            },
            "cnt_age75": { # count of population 75 years or older
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            },   
            "cnt_disab": { # count of disabled population 
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            },
            "cnt_age17": { # count of population younger than 18 years 
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            },
            "vpi_score": { # vulnerable population index score
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            }
            
        }
    },
    "Traffic Signals":  {
        "layerName": "Traffic_Signals",
        "processType": "NeedOnlyGeoms",
        "geometryType": ["Point"],
        "attributes": None
    },
    "All Pedestrian Crashes":  {
        "layerName": "AllPedestrianCrashes",
        "processType": "NeedOnlyGeoms",
        "geometryType": ["Point", "Multipoint"],
        "attributes": None
    },
    "Pedestrian Fatalities and Severe Injuries": {
        "layerName": "FatalandSeverePedCrshs",
        "geometryType": ["Point", "Multipoint"],
        "processType": "NeedOnlyGeoms",
        "attributes": None
    },
    "Multi-Jurisdictional or Multi-Agency Coordination": {
        "layerName": "Jurisdictions",
        "geometryType": ["Polygon", "Multipolygon"],
        "processType": "NeedOnlyGeoms",
        "attributes": None
    },
    "Schools, Public K - 12":  {
        "layerName": "SchoolsK12",
        "geometryType": ["Point", "Multipoint"],
        "processType": "NeedOnlyGeoms",
        "attributes": None
    }, 
    "Higher Education, College and Universities":  {
        "layerName": "HigherEducation",
        "geometryType": ["Point", "Multipoint"],
        "processType": "NeedOnlyGeoms",
        "attributes": None
    }, 
    "Retail Locations":  {
        "layerName": "RetailLocations",
        "geometryType": ["Point", "Multipoint"],
        "processType": "NeedOnlyGeoms",
        "attributes": None
    }, 
    "Intersections":  {
        "layerName": "Intersections",
        "geometryType": ["Point", "Multipoint"],
        "processType": "NeedOnlyGeoms",
        "attributes": None
    },
    "Minor Transit Stops":  {
        "layerName": "MinorTransitStops",
        "geometryType": ["Point", "Multipoint"],
        "processType": "NeedOnlyGeoms",
        "attributes": None
    }, 
    "Major Transit Stops":  {
        "layerName": "MajorTransitStops",
        "geometryType": ["Point", "Multipoint"],
        "processType": "NeedOnlyGeoms",
        "attributes": None
    }, 
    "Functional Classification":  {
        "layerName": "FunctionalClassification",
        "geometryType": ["Polyline", "Multipolyline"],
        "processType": "CheckAttributes",
         "attributes": {
            "functional": {
                "type": ['integer', 'real'],
                "att_values": 'Non Negative'
            }
        }
    }
}



def getRequiredAttributes(layerInfo, key):
    """
    Returns list of required attribute names from layerInfo object in import_shapefiles.py 
    args: 
        key       -- key of information to access
        value     -- nested key value of information to access
        attribute -- name of attribute from when values are wanted  
    """
    if layerInfo[key]['attributes'] is not None:
        return list(layerInfo[key]['attributes'].keys())
    else:
        return None

def getLayerName(layerInfo, key):
    """
    Returns final layer name
    args: 
        key     -- key of information to access
    """
    return layerInfo[key]["layerName"] 

def getExpectedAttrValues(layerInfo, key, value):
    """
    Utility function to access values from a given set of key combinations from layerInfo object in import_shapefiles.py 
    args: 
        key     -- key of information to access
        value   -- nested key value of information to access
    """
    if layerInfo[key]['attributes'] is not None:
        return layerInfo[key]["attributes"][value]["att_values"]
    else:
        return None
   
def getExpectedAttrDataType(layerInfo, key, val):
    """
    Utility function to access values from a given set of key combinations from layerInfo object in import_shapefiles.py 
    args: 
        key     -- key of information to access
        value   -- nested key value of information to access
    """
    if layerInfo[key]['attributes'] is not None:
        return layerInfo[key]["attributes"][val]["type"]
    else:
        return None

def getKeysFromValue(layerInfo, key, val):
    """
    Returns list of keys that match given values from layerInfo object in import_shapefiles.py 
    args: 
        key -- subkey with specific value to return from
        val -- value of subkey to identify which keys to return
    """
    return [k for k,v in layerInfo.items() if v[key] == val]

def getExpectedGeometry(layerInfo, key):
    """
    Returns expected geometry in for a given feature class 
    args: 
        key -- subkey with specific value to return from
        val       -- value of subkey to identify which keys to return
    """
    if layerInfo[key]['geometryType'] is not None:
        return layerInfo[key]["geometryType"]
    else:
        return None
