sub_params = {
    "factorOpportunity": {
        'measureGrantFunding': {
            'table': 'GrantFundingCandidateList',
            'name': 'Grant Funding Candidate',
            'cell_index': 2
        }, 
        'measureCoincidesRoadwayImprovement': {
            'table': 'CoincidesPlannedRoadwayImprovement',
            'name': 'Coincides with Planned Roadway Improvement / Maint',
            'cell_index': 3
        }
    },
    "factorConstraints": {
        'measureMultiJurisdictional': {
            'table': 'Jurisdictions',
            'name': 'Multi-Jurisdictional or Multi-Agency Coordination',
            'cell_index': 4
        },
        'measureCost': {
            'table': 'CostList',
            'name': 'Cost',
            'cell_index': 5
        },
    },
    'factorStakeholder': {
        'measureAdvisoryCommittee': {
            'table': 'AdvisoryCommitteeRecs',
            'name': 'Recommended by Advisory Committee',
            'cell_index': 6
        },
        'measureAdoptedPlan': {
            'table': 'PlannedAppvList',
            'name': 'Plan / Approved List',
            'cell_index': 7
        },
    },
    'factorEquity': {
        'measureDisabilities': {
            'table': 'VulnerablePopulationsIndex',
            'name': 'Density of Disabled Population',
            'column': 'cnt_disab',
            'cell_index': 8
        },
        'measureIncome': {
            'table': 'VulnerablePopulationsIndex',
            'name': 'Density of Households Below Poverty',
            'column': 'cnt_hh_pvr',
            'cell_index': 9
        },
        'measureLimitedEnglishProficiency': {
            'table': 'VulnerablePopulationsIndex',
            'name': 'Density of Population with Limited English Proficiency',
            'column': 'cnt_lep',
            'cell_index': 10
        },
        'measureVehicleAccess': {
            'table': 'VulnerablePopulationsIndex',
            'name': 'Density of Zero Car Households',
            'column': 'cnt_hh_noc',
            'cell_index': 11
        },
        'measureOlderPopulation': {
            'table': 'VulnerablePopulationsIndex',
            'name': 'Density of Population Over 75 Years Old',
            'column': 'cnt_age75',
            'cell_index': 12
        },
        'measureHispanicPopulation': {
            'table': 'VulnerablePopulationsIndex',
            'name': 'Density of Hispanic Population',
            'column': 'cnt_hisp',
            'cell_index': 13
        },
        'measureNonWhitePopulation': {
            'table': 'VulnerablePopulationsIndex',
            'name': 'Density of Non White or Hispanic Population',
            'column': 'cnt_not_wh',
            'cell_index': 14
        },
        'measureYoungerPopulation': {
            'table': 'VulnerablePopulationsIndex',
            'name': 'Density of Population Under 18 Years Old',
            'column': 'cnt_age17',
            'cell_index': 15
        },
        'measureVPI': {
            'table': 'VulnerablePopulationsIndex',
            'name': 'Vulnerable Population Index',
            'column': 'vpi_score',
            'cell_index': 16
        },
    },
    'factorConnectivity': {
        'measurePedestrianNetwork': {
            'table': 'PedestrianNetwork',
            'name': 'Pedestrian Network Connectivity',
            'column': 'CateTitle',
            'cell_index': 17
        },
        'measureIntersectionDensity': {
            'table': 'Intersections',
            'name': 'Intersection Density',
            'cell_index': 18
        },
    },
    'factorPedTripPotential': {
        'measurePopulationDensity': {
            'table': 'PopulationCounts',
            'name': 'Population Density',
            'column': 'tot_pop',
            'cell_index': 19
        },
        'measureEmploymentDensity': {
            'table': 'EmploymentCounts',
            'name': 'Employment Density',
            'column': 'tot_emp',
            'cell_index': 20
        },
        'measureSchools': {
            'table': 'SchoolsK12',
            'name': 'Public Schools, K - 12',
            'cell_index': 21
        },
        'measureHigherEducation': {
            'table': 'HigherEducation',
            'name': 'Higher Education',
            'cell_index': 22
        },
        'measureRetail': {
            'table': 'RetailLocations',
            'name': 'Retail Locations',
            'cell_index': 23
        },
        'measureMinorTransit': {
            'table': 'MinorTransitStops',
            'name': 'Minor Transit Stops',
            'cell_index': 24
        },
        'measureMajorTransit': {
            'table': 'MajorTransitStops',
            'name': 'Major Transit Stops',
            'cell_index': 25
        },
    },
    'factorSafety': {
        'measureCrashes': {
            'table': 'AllPedestrianCrashes',
            'name': 'Pedestrian Crash Density',
            'cell_index': 26
        },
        'measureSevereFatalCrashes': {
            'table': 'FatalandSeverePedCrshs',
            'name': 'Pedestrian Severe or Fatal Pedestrian Crash Density',
            'cell_index': 27
        },
        'measureFunctionalClass': {
            'table': 'FunctionalClassification',
            'name': 'Functional Classification',
            'column': 'functional',
            'cell_index': 28
        },
    }
}

variable_wt_col = 'D'
variable_include_col = 'F'
factor_wt_col = 'C'

factor_params = {
    'factorOpportunity': {
        'wt_cell_row': 32,
        'raw_score_col': 2
    },
    'factorConstraints': {
        'wt_cell_row': 33,
        'raw_score_col': 3
    },
    'factorStakeholder': {
        'wt_cell_row': 34,
        'raw_score_col': 4
    },
    'factorEquity': {
        'wt_cell_row': 35,
        'raw_score_col': 5
    },
    'factorConnectivity': {
        'wt_cell_row': 36,
        'raw_score_col': 6
    },
    'factorPedTripPotential': {
        'wt_cell_row': 37,
        'raw_score_col': 7
    },
    'factorSafety': {
        'wt_cell_row': 38,
        'raw_score_col': 8
    }
}